#pragma once

#include <QWidget>

#include "core/core.h"
#include "controls.h"
#include "edit.hpp"
#include "nstslider.h"

class QLabel;
class QComboBox;
class QCheckBox;
class QProgressBar;
namespace graphed {

class TCheckableButton;
class TWToolBox;
class TWView;
class TWMisc;
class TWProperties;
class TGraphEditor: public QWidget
{
    Q_OBJECT
public slots:
    void SendSelectionParams();
    void SetParams(qreal cx, qreal cy, qreal w, qreal h);
    void SetLocked(const bool Lock);
    void slSetLitoType(int);
    void slSetVout(int);
    void updatePrbar();
    void Finish();
    void startPrbar(bool);

    void sl_setHeadRange(double,double, double);
    void sl_setStageRange(double,double, double);
    void sl_setRange(int);
    void setZpos();
    void setXYpos(double x, double y);
    void updZ1(double z);
    void updZ2(double z);
    void setX1(double);
    void setY1(double);
    void setX2(double);
    void setY2(double);
    void syncXY();
    void syncZ();
    void syncXYZrange();

signals:
    void syncX1pos(double);
    void syncX2pos(double);
    void syncY1pos(double);
    void syncY2pos(double);
    void sig_XYPosition(double, double);
    void sig_XYPosition2(double, double);
    void sig_ZPosition(double);
    void sig_ZPosition2(double);

public:
    TWToolBox *ToolBox;
    TWView *View;
    TWMisc *Misc;
    TWProperties *WProperties;
    QLabel *LlithoVout;
    void closeEvent(QCloseEvent *event);

    TGraphEditor(QWidget *parent = 0);
    TCheckableButton *BStartStop;
    QProgressBar *PBProgress;
    QTimer *TxyUpdate;
    QCheckBox *CBisContinuous;
    TWView *GetView() const { return View; }
    QComboBox *BLithoType;
    QComboBox *BScanner;
    QComboBox *BlithoVout;
    Edit *LInfo_cx;
    Edit *LInfo_cy;
    Edit *LInfo_w;
    Edit *LInfo_h;
    NSTSlider *LInfo_z;

    double x1, x2, y1, y2, z1, z2;
    double xHeadRange,yHeadRange, zHeadRange;
    double xStageRange,yStageRange, zStageRange;
};

}
