#ifndef TMOUSEEVENT_H
#define TMOUSEEVENT_H

#include <QPointF>
#include <QMouseEvent>

namespace graphed {

class TMouseEvent: public QMouseEvent
   {
      const QPointF Pos;
   public:
      TMouseEvent(const QMouseEvent *e, const QPointF &p): QMouseEvent(e->type(), p.toPoint(), e->button(), e->buttons(), e->modifiers()),
                                                           Pos(p) { }
      virtual ~TMouseEvent() { }
      QPointF posF() const { return Pos; }
   };

}

#endif // TMOUSEEVENT_H
