#include "core.h"
#include <QDebug>

namespace graphed {

TPointFList GraphEd::GetHandlePoints(const QRectF &Rect, const bool DoSort)
   {
      return GetHandlePoints(Rect.topLeft(), Rect.topRight(), Rect.bottomRight(), Rect.bottomLeft(), DoSort);
   }
TPointFList GraphEd::GetHandlePoints(const QPointF &TL, const QPointF &TR, const QPointF &BR, const QPointF &BL, const bool DoSort)
   {
      return GetHandlePoints(TPointFList() << TL << TR << BR << BL, DoSort);
   }
TPointFList GraphEd::GetHandlePoints(const TPointFList &Corners, const bool DoSort)
   {
      if (Corners.size() < 4) { qDebug() << "GraphEd::GetHandlePoints(const TPointFList &Corners): Corners.size() < 4!";  return TPointFList() << QPointF() << QPointF() << QPointF() << QPointF(); }
      QPointF TL, TR, BR, BL;
      if (DoSort)
         {
            TPointFList Temp = Corners;
            qSort(Temp.begin(), Temp.end(), GraphEd::CompareY);
            if (Temp[0].x() > Temp[1].x()) { TR = Temp[0]; TL = Temp[1]; }
            else                          { TR = Temp[1]; TL = Temp[0]; }
            if (Temp[2].x() > Temp[3].x()) { BR = Temp[2]; BL = Temp[3]; }
            else                          { BR = Temp[3]; BL = Temp[2]; }
         }
      else { TL = Corners[0]; TR = Corners[1]; BR = Corners[2]; BL = Corners[3]; }
      return TPointFList() << TL << (TL + TR) / 2. <<  TR << (TR + BR) / 2. <<  BR << (BR + BL) / 2. <<  BL << (BL + TL) / 2.;
   }
}

