#include "TMisc.h"
#include <QSizeF>
#include <QRectF>

namespace graphed {

QSizeF TMisc::CalcNewSize(const QSizeF &DesirableSize, const QRectF &Limits, const TSizeTypeCalc CalcType)
   {
      const QRectF NormLimits = Limits.normalized();
      QSizeF Result = DesirableSize;
      if (NormLimits.isEmpty() || CalcType == TSTC_DoNotChange) return Result;
      const qreal k = NormLimits.height() / NormLimits.width();
      if (CalcType == TSTC_MinSize)      Result.height() / Result.width() < k ? Result.setWidth(Result.height() / k) : Result.setHeight(Result.width() * k);
      else if (CalcType == TSTC_MaxSize) Result.height() / Result.width() < k ? Result.setHeight(Result.width() * k) : Result.setWidth(Result.height() / k);
      return Result;
   }

}
