#include "TSIUnit.h"
#include <QPair>
#include <QApplication>

namespace graphed {

void TSIUnit::UpdateMultiplier(double Value)
{
    Value = fabs(Value);

    if (SIUnit.isEmpty() || !Value) {
        StrMultiplier.clear();
        Multiplier = 1;
        return;
    }

    typedef QPair<const char *, double> PairStrDbl;
    const PairStrDbl Multipliers[] = {
        PairStrDbl(QT_TR_NOOP("M"), 1e6), PairStrDbl(QT_TR_NOOP("k"), 1e3),
        PairStrDbl("", 1), PairStrDbl(QT_TR_NOOP("m"), 1e-3),
        PairStrDbl(QT_TR_NOOP("micro"), 1e-6), PairStrDbl(QT_TR_NOOP("n"), 1e-9),
        PairStrDbl(QT_TR_NOOP("p"), 1e-12)
    };
    const int size = sizeof(Multipliers) / sizeof(*Multipliers) - 1;
    const double Bound = 1.1;
    int FoundIndex = 2; //unit 1

    if (Value < Bound * Multipliers[size].second)
        FoundIndex = size;

    if (Value > Bound * Multipliers[0].second)
        FoundIndex = 0;

    for (int i = 0; i <= size; i++)
        if (Value / Multipliers[i].second <= 1000*Bound && Value / Multipliers[i].second >= Bound) {
            FoundIndex = i;
            break;
        }

    StrMultiplier = qApp->translate("graphed::TSIUnit", Multipliers[FoundIndex].first);
    Multiplier = Multipliers[FoundIndex].second;
}

void TSIUnit::UpdateLegend()
{
    Legend = Description + (Description.isEmpty() || SIUnit.isEmpty() ? "" : ", ") + StrMultiplier + SIUnit;
}

}
