#ifndef TSIUNIT_H
#define TSIUNIT_H

#include "core/core.h"
#include <math.h>

namespace graphed {

class TSIUnit
{
public:
    double Multiplier;
    QString StrMultiplier;
    QString Description;
    QString SIUnit;
    QString Legend;

    TSIUnit()
    {
        Multiplier = 1;
    }
    void SetDescription(const QString &Desc)
    {
        Description = Desc;
        UpdateLegend();
    }
    void SetSIUnit(const QString &Unit)
    {
        SIUnit = Unit;
        UpdateLegend();
    }
    void SetDescAndSIUnit(const QString &Desc, const QString &Unit)
    {
        Description = Desc;
        SIUnit = Unit;
        UpdateLegend();
    }
    void UpdateMultiplier(double Value);
    void UpdateLegend();
    void UpdateLegend(double Value) { UpdateMultiplier(Value); UpdateLegend(); }
    void UpdateLegend(double FirstBound, double SecondBound) { UpdateLegend(qMax(fabs(FirstBound), fabs(SecondBound))); }
};

}

#endif // TSIUNIT_H
