#include "TConvertor.h"

namespace graphed {
namespace out {

qreal TVoltColourConvertor::Colour2Voltage(const QRgb &Colour, const qreal MinV, const qreal MaxV)
{
    const qreal RelVal = 1.*(qRed(Colour) + qGreen(Colour) + qBlue(Colour)) / (MaxChannelVal * 3);
    return MinV + RelVal * (MaxV - MinV);
}
QColor TVoltColourConvertor::Voltage2Colour(const qreal V1, const qreal MinV, const qreal MaxV)
{
    const qreal RelVal = (V1 - MinV) / (MaxV - MinV);
    return QColor(255, 0, 0, MaxChannelVal * RelVal);
}

}
}
