#include "TResults.h"

namespace graphed {
namespace out {

qreal TVarVoltage::FindVoltage(STLPointFVector::const_iterator PointIt) const
{
    STLPointFVector::difference_type Diff = PointIt - m_PointList.begin();
    return m_VList[Diff];
}
TVtData TVarVoltage::VtData1(STLPointFVector::const_iterator PointIt) const
{
    return TVtData(FindVoltage(PointIt), m_t1);
}

STLPointVector Line(QPoint p1, QPoint p2)
{

    STLPointVector Result;
    STLPointVector Result1;
    //QPoint  pfl;
    //STLPointVector::const_iterator PointIt;
    int deltax = qAbs(p2.x() - p1.x());
    int deltay = abs(p2.y() - p1.y());
    int error = 0;
    bool revers = false;
    bool Mirror = false;

    if (deltax > deltay)
    {
        int Average = (p1.y() + p2.y()) / 2;
        if (p1.x() > p2.x()) {qSwap(p1, p2); revers=true;}
        if (p1.y() > p2.y()) { qSwap(p1.ry(), p2.ry()); Mirror = true; }
        int deltaerr = deltay;
        int y = p1.y();
        for (int x = p1.x(); x < p2.x(); x++)
        {
            if (Mirror)
            {
                int _y = y; _y -= Average; _y -= 2 * _y; _y += Average;
                Result.push_back(QPoint(x, _y));
            }
            else Result.push_back(QPoint(x, y));
            error += deltaerr;
            if (2 * error >= deltax)
            {
                ++y;
                error -= deltax;
            }
        }
        if (revers)
        {
            // for (PointIt = Result.begin(); PointIt != Result.end(); PointIt++)
            // {pfl=*PointIt; Result1.push_back(pfl);}
            // Result1.resize(Result.size());
            for (unsigned int i=0; i<Result.size();i++)
                Result1.push_back(Result.at(Result.size()-1-i));
        }
    }
    else
    {
        int Average = (p1.x() + p2.x()) / 2;
        if (p1.y() > p2.y()) {qSwap(p1, p2);revers=true;}
        if (p1.x() > p2.x()) { qSwap(p1.rx(), p2.rx()); Mirror = true; }
        int deltaerr = deltax;
        int x = p1.x();
        for (int y = p1.y(); y < p2.y(); y++)
        {
            if (Mirror)
            {
                int _x = x; _x -= Average; _x -= 2 * _x; _x += Average;
                Result.push_back(QPoint(_x, y));
            }
            else Result.push_back(QPoint(x, y));
            error += deltaerr;
            if (2 * error >= deltay)
            {
                ++x;
                error -= deltay;
            }
        }
        if (revers)
        {
            for (unsigned int i=0; i<Result.size();i++)
                Result1.push_back(Result.at(Result.size()-1-i));
        }
    }
    if (revers) return Result1;
    else        return Result;
}

STLPointVector Circle(const QPoint &c, const int r)
{
    int x = 0, y = r, delta = 2 - 2 * r, error = 0;
    const int Xc = c.x(), Yc = c.y();
    STLPointVector Result, Result1, Result2, Result3, Result4;
    while (y >= 0)
    {
        Result1.push_back(QPoint(Xc + x, Yc + y));
        Result2.push_back(QPoint(Xc + x, Yc - y));
        Result3.push_back(QPoint(Xc - x, Yc + y));
        Result4.push_back(QPoint(Xc - x, Yc - y));

        error = 2 * (delta + y) - 1;
        if ((delta < 0) && (error <= 0))
        {
            delta += 2 * ++x + 1;
            continue;
        }
        error = 2 * (delta - x) - 1;
        if ((delta > 0) && (error > 0))
        {
            delta += 1 - 2 * --y;
            continue;
        }
        x++;
        delta += 2 * (x - y);
        y--;
    }
    Result.insert(Result.end(), Result1.begin(), Result1.end());
    Result.insert(Result.end(), Result2.rbegin(), Result2.rend());
    Result.insert(Result.end(), Result4.begin(), Result4.end());
    Result.insert(Result.end(), Result3.rbegin(), Result3.rend());
    return Result;
}

}
}
