#ifndef TDATASHAPE_H
#define TDATASHAPE_H

#include "shape/TMetaData.h"
#include "shape/TShape.h"
#include "shape/TShape_p.h"

namespace graphed {

class TDataShapePrivate: public TShapePrivate
   {
   public:
      TDataShapePrivate() { }
      virtual ~TDataShapePrivate() { }
   };

template <class T>
class TDataShape: public TShape, public TMetaData<T>
   {
      Q_DECLARE_PRIVATE(TDataShape);
   protected:

      TDataShape(TDataShapePrivate &dd): TShape(dd) { }
      void SaveTransform(QDataStream &Stream) const
         {
            qreal sig(-1.2345e5);
            Stream << sig << this->Speed() << this->MetaData1() << false;
            Stream << Transformation().m11() << Transformation().m12() << Transformation().m13() <<
                      Transformation().m21() << Transformation().m22() << Transformation().m23() <<
                      Transformation().m31() << Transformation().m32() << Transformation().m33();
        }
      void LoadTransform(QDataStream &Stream)
         {
            qreal m11, m12, m13, m21, m22, m23, m31, m32, m33;
            qreal sig(-1.2345e5), test;
            Stream >> test;
            if (test != sig)
                m11 = test;
            else {
                Stream >> this->Speed();
                Stream >> this->MetaData1();
                bool t; Stream >> t;
                Stream >> m11;
            }
            Stream >> /*m11 >>*/ m12 >> m13 >>
                      m21 >> m22 >> m23 >>
                      m31 >> m32 >> m33;
            SetTransformation(QTransform(m11, m12, m13, m21, m22, m23, m31, m32, m33));
         }
   public:
      virtual ~TDataShape() { }
   };

}

#endif // TDATASHAPE_H
