#ifndef TELLIPSECURVESHAPE_H
#define TELLIPSECURVESHAPE_H

#include "shape/TDataShape.h"
#include "out/TResults.h"
#include <QPainterPath>

namespace graphed {

class TEllipseCurveShapePrivate;
class TEllipseCurveTool;
class TEllipseCurveShape: public TDataShape<out::TVtData>
   {
      friend class TEllipseCurveTool; // for paint
      Q_DECLARE_PRIVATE(TEllipseCurveShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TEllipseCurveShape();
      void SetCenter(const QPointF &p);
      void SetAngles(const QPointF &p);
      bool SetFreePoint(const QPointF &p);
      void SetNextParam();
      virtual void SetFloatParameter(int id, qreal val);
      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TEllipseCurveShape"; }
   };

typedef QSharedPointer<TEllipseCurveShape> TEllipseCurveShapeSP;

}

#endif // TELLIPSECURVESHAPE_H
