#ifndef TELLIPSESHAPE_H
#define TELLIPSESHAPE_H

#include "shape/TDataShape.h"
#include "out/TResults.h"

namespace graphed {

class TEllipseShapePrivate;
class TEllipseTool;
class TEllipseShape: public TDataShape<out::TVtData>
   {
      friend class TEllipseTool; // for paint
      Q_DECLARE_PRIVATE(TEllipseShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TEllipseShape();
      void SetCenter(const QPointF &p);
      void SetFreePoint(const QPointF &p);
      virtual void SetFloatParameter(int id, qreal val);
      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TEllipseShape"; }
   };

typedef QSharedPointer<TEllipseShape> TEllipseShapeSP;

}

#endif // TELLIPSESHAPE_H
