#ifndef TIMAGESHAPE_H
#define TIMAGESHAPE_H

#include "shape/TDataShape.h"
#include "out/TResults.h"

namespace graphed {

class TImageShapePrivate;
class TImageTool;
class TImageShape: public QImage, public TDataShape<out::TVtData>
   {
      friend class TImageTool; // for paint
      Q_DECLARE_PRIVATE(TImageShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TImageShape();
      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TImageShape"; }
   };

typedef QSharedPointer<TImageShape> TImageShapeSP;

}

#endif // TIMAGESHAPE_H
