#ifndef TIMAGESHAPE_P_H
#define TIMAGESHAPE_P_H

#include "TImageShape.h"

namespace graphed {


class TPixelPartInfo
   {
      QPoint m_Point;
      qreal m_Part = 0.;
   public:
      TPixelPartInfo() { }
      TPixelPartInfo(const QPoint &Point, const qreal Part): m_Point(Point), m_Part(Part) { }
      QPoint Point() const { return m_Point; }
      qreal Part() const { return m_Part; }
   };

class TPixelInfo
   {
      QPoint m_Point;
   public:
      TPixelInfo(const QPoint &Point = QPoint()): m_Point(Point), Voltage(0) { }
      QPoint Point() const { return m_Point; }
      void SetPoint(const QPoint &P) { m_Point = P; }
      qreal Voltage;
      //qreal SummuryPart;
   };

class TImageShapePrivate: public TDataShapePrivate
   {
      bool IsBetween(const qreal Min, const qreal Max, const qreal Val) const { return Val >= Min && Val <= Max; }
      int ToZero(const qreal Val) const   { return static_cast<int>(Val); }
      int FromZero(const qreal Val) const { return static_cast<int>(Val) + GraphEd::Sign(Val) * (Val - static_cast<int>(Val) ? 1 : 0); }

   public:
      typedef QVector<TPixelPartInfo> TPixelPartInfoList;
      typedef QVector<TPixelInfo> TPixelInfoList;

      TImageShapePrivate() { }
      virtual ~TImageShapePrivate() { }
      TPixelPartInfoList PixelPartInfoList(const QRectF &DocR) const;
   };

}



#endif // TIMAGESHAPE_P_H
