#ifndef TLINESSHAPE_H
#define TLINESSHAPE_H

#include "shape/TDataShape.h"
#include "core/core.h"
#include "out/TResults.h"

namespace graphed {

class TLinesShapePrivate;
class TLineTool;
class TLinesShape: public TDataShape<out::TVtData>
   {
      friend class TLineTool; // for paint
      Q_DECLARE_PRIVATE(TLinesShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TLinesShape();
      void AddPoint(const QPointF &p);
      void SetFreePoint(const QPointF &p);
      void UnsetFreePoint();
      TPointFList::size_type PointsCount() const;

      virtual void SetFloatParameter(int id, qreal val);
      virtual void SetIntParameter(int id, quint32 val);
      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TLinesShape"; }
   };

typedef QSharedPointer<TLinesShape> TLinesShapeSP;

}

#endif // TLINESSHAPE_H
