#ifndef TPointSHAPE_H
#define TPointSHAPE_H

#include "core/core.h"
#include "out/TResults.h"
#include "shape/TDataShape.h"

namespace graphed {

class TPointShapePrivate;
class TPointTool;
class TPointShape: public TDataShape<out::TVtData>
   {
      friend class TPointTool; // for paint
      Q_DECLARE_PRIVATE(TPointShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TPointShape();
      void SetFreePoint(const QPointF &p);
      virtual void SetFloatParameter(int id, qreal val);
      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TPointShape"; }
   };

typedef QSharedPointer<TPointShape> TPointShapeSP;

}

#endif // TPointSHAPE_H
