#include "TProgressInfo.h"

#include <QMutex>

namespace graphed {

class TProgressInfoPrivate
{
public:
    TProgressInfoPrivate():Progress(0) { }

    mutable int Progress;
    mutable QMutex AccessControl;
};

TProgressInfo::TProgressInfo(): d_ptr(new TProgressInfoPrivate)
{
}
int TProgressInfo::Progress() const
{
    Q_D(const TProgressInfo);
    QMutexLocker lck(&d->AccessControl);
    return d->Progress;
}
void TProgressInfo::SetProgress(int P) const
{
    Q_D(const TProgressInfo);
    d->AccessControl.lock();
    d->Progress = qBound(0, P, 100);
    d->AccessControl.unlock();
}

}
