#ifndef TRECTSHAPE_H
#define TRECTSHAPE_H

#include "shape/TDataShape.h"
#include "out/TResults.h"

namespace graphed {

class TRectShapePrivate;
class TLineTool;
class TRectShape: public TDataShape<out::TVtData>
   {
      friend class TRectTool; // for paint
      Q_DECLARE_PRIVATE(TRectShape);

   protected:
      virtual void paint(QPainter *p, const TConversionBase *Convert) const;
      virtual bool IsIn(const QPointF &PF) const;
      virtual out::TResults *ToPointList() const;
      virtual void SaveToFile(QDataStream &Stream) const;
      virtual void LoadFromFile(QDataStream &Stream);
   public:
      TRectShape();
      void SetStartPoint(const QPointF &p);
      void SetEndPoint(const QPointF &p);

      virtual QRectF BoundingRect() const;
      static QString ShapeName() { return "TRectShape"; }
   };

typedef QSharedPointer<TRectShape> TRectShapeSP;

}

#endif // TRECTSHAPE_H
