#ifndef TSELECTIONSHAPE_H
#define TSELECTIONSHAPE_H

#include "shape/TShape.h"

namespace graphed {

class TSelectionShapePrivate;
class TSelectionShape: public TShape
{
    Q_OBJECT
    Q_DECLARE_PRIVATE(TSelectionShape);
private:
    void paint(QPainter *p, const TConversionBase *Convert) const { Q_UNUSED(p); Q_UNUSED(Convert); }
    virtual out::TResults *ToPointList() const { return NULL; }
    virtual void SaveToFile(QDataStream &Stream) const { Q_UNUSED(Stream); }
    virtual void LoadFromFile(QDataStream &Stream) { Q_UNUSED(Stream); }
public slots:
    void InvalidateCache();
signals:
    void SelectionChanged();
    void setenabled(bool);
    void empty();
public:
    explicit TSelectionShape();
    virtual ~TSelectionShape();
    void Select(const TShapeSP Shape);
    void DeSelect(const TShapeSP Shape);
    void DeSelectAll();

    const TShapeList &SelectedShapes() const;
    TShapeList &SelectedShapes();
    TShapeList::size_type count() const;

    QRectF BoundingRect() const;

    bool IsSelected(const TShapeSP Shape) const;
};

typedef QSharedPointer<TSelectionShape> TSelectionShapeSP;

}

#endif // TSELECTIONSHAPE_H
