#include "TShapeFactory.h"
#include "shape/TEllipseCurveShape.h"
#include "shape/TEllipseShape.h"
#include "shape/TImageShape.h"
#include "shape/TLinesShape.h"
#include "shape/TRectShape.h"
#include "shape/TPointShape.h"
#include <QDebug>

namespace graphed {

TShapeFactory *TShapeFactory::Self = NULL;
bool TShapeFactory::IAmBeingCreatedNow = false;
TShapeFactory::TShapeFactory()
   {
      Register<TEllipseCurveShape>(TEllipseCurveShape::ShapeName());
      Register<TEllipseShape>(TEllipseShape::ShapeName());
      Register<TImageShape>(TImageShape::ShapeName());
      Register<TLinesShape>(TLinesShape::ShapeName());
      Register<TRectShape>(TRectShape::ShapeName());
      Register<TPointShape>(TPointShape::ShapeName());
   }
TShapeFactory::~TShapeFactory() { }
TShapeFactory *TShapeFactory::Instance(const int Line, const char *File)
   {
      if (IAmBeingCreatedNow)
         { qDebug() << "TShapeFactory::Instance() was called from " << File << " and line #" << Line << "! Returning NULL..."; return NULL; }
      if (!Self)
         {
            IAmBeingCreatedNow = true;
            Self = new TShapeFactory;
            IAmBeingCreatedNow = false;
         }
      return Self;
   }
void TShapeFactory::Destroy()  { delete Self; Self = 0;  }

}
