#ifndef TDEFAULTTOOL_H
#define TDEFAULTTOOL_H
#include "tools/TInteractionTool.h"
#include "shape/TShape.h"
#include "core/core.h"

namespace graphed {

class TDefaultTool: public TInteractionTool
{
    Q_OBJECT

    virtual TInteractionStrategy *CreateStrategy(TMouseEvent *e) const;
    virtual void paint(QPainter *p, const TConversionBase *Convert);
    virtual void mouseMoveEvent(TMouseEvent *e);
    virtual void keyPressEvent(QKeyEvent *e);
    virtual void Deactivate();

    enum TAction { Act_Move, Act_Rotate, Act_Resize, Act_None };
    TDefaultTool::TAction GetAction(const TShapeSP Shape, const QPointF &MousePos) const;

public slots:
    void on_DeletePressed();
public:
    static QString ToolName() { return "TDefaultTool"; }
    static const unsigned int HandleDistance = 10;
    static GraphEd::THandles HandleAt(const TShapeSP Shape, const QPointF &WidgetPos, const bool DoSort = true, const unsigned int Dist = TDefaultTool::HandleDistance);
    TDefaultTool(TCanvas *c);
};

void SetSelectionParams(qreal cx, qreal cy, qreal w, qreal h);

}

#endif // TDEFAULTTOOL_H
