#ifndef TRESIZESTRATEGY_H
#define TRESIZESTRATEGY_H

#include "tools/TInteractionStrategy.h"
#include "core/core.h"

namespace graphed {

class TResizeStrategy: public TInteractionStrategy
{
    QList<QTransform> OldTransforms;
    QPointF Center;
    QPointF FixedPoint;
    QPointF FixedCorner;
    QSizeF StartSize;
    bool Top, Bottom, Left, Right;
    bool StartSizeWasCalcedRelativeCenter;
    GraphEd::THandles ActiveHandle;

    void UpdateStartSize(const bool ControlModifier);
    virtual void handleMouseMove(TMouseEvent *e);
    void CancelInteraction();
public:
    TResizeStrategy(const TCanvasQP c, TMouseEvent *e);
    ~TResizeStrategy();
    static QCursor Cursor(const QPointF &Pos);
};

}

#endif // TRESIZESTRATEGY_H
