#include "TRotateStrategy.h"

#include "core/TMouseEvent.h"
#include "core/core.h"

namespace graphed {

TRotateStrategy::TRotateStrategy(const TCanvasQP c, TMouseEvent *e): TInteractionStrategy(c, e->posF())
{
    if (!INSTANCE(ShapeManager)->Selection()->count()) return;

    Canvas->setCursor(TRotateStrategy::Cursor());

    foreach (TShapeSP Shape, SelectedShapes) OldTransforms << Shape->Transformation();

    TShapeSP Shape = SelectedShapes.size() == 1 ? SelectedShapes.front() : (TShapeSP)INSTANCE(ShapeManager)->Selection();
    Center = Shape->BoundingRect().center();
    InitialLine = QLineF(Shape->GlobalPosition(Center), e->posF());
}

void TRotateStrategy::handleMouseMove(TMouseEvent *e)
{
    if (SelectedShapes.isEmpty()) return;

    TShapeSP Shape =SelectedShapes.size() == 1 ? SelectedShapes.front() : (TShapeSP)INSTANCE(ShapeManager)->Selection();
    qreal Delta = -InitialLine.angleTo(QLineF(Shape->GlobalPosition(Center), e->posF()));

    TShapeList::size_type i = 0;
    foreach (TShapeSP Shape, SelectedShapes)
    {
        QTransform RotateMatrix;
        RotateMatrix.translate(Center.x(), Center.y());
        RotateMatrix.rotate(Delta);
        RotateMatrix.translate(-Center.x(), -Center.y());
        RotateMatrix = RotateMatrix * OldTransforms[i++];
        Shape->SetTransformation(RotateMatrix);
    }
    Canvas->update();
}

}
