#ifndef TAPPLYTOOL_P_H
#define TAPPLYTOOL_P_H

#include "TApplyTool.h"
#include "shape/TImageShape.h"
#include <QThread>
#include <QMutex>
#include <QTimer>

namespace graphed {

class TApplyToolThreadInfo
{
    mutable QMutex AccessControl;
    int m_Progress;
    QString m_CurrentOperation;
    TShapeSP m_CurrentShape;
public:
    TApplyToolThreadInfo(): m_Progress(0) { }
    int Progress() const;
    void SetProgress(const int P);
    QString CurrentOperation() const;
    void SetCurrentOperation(const QString &Text);
    TShapeSP CurrentShape() const;
    void SetCurrentShape(const TShapeSP Shape);
    void ResetAllProgressInfo();
};

class TApplyToolThread: public QThread, public TApplyToolThreadInfo
{
    void run();
    void MakeOutputResults();
    void MakeImage();

public:
    TApplyToolThread(TApplyToolPrivate *qq);
    TApplyToolPrivate * const parent;
};

class TApplyToolPrivate : public QObject
{
    Q_OBJECT
signals:
    void SetProgress(int Progress, const QString &Text);
private slots:
    void on_started();
    void on_finished();
    void on_Timer_timeout();
private:
    QString ParamsToString(const int X, const int Y) const;
    QTimer Timer;
public:
    TApplyToolPrivate();

    TApplyTool *parent;
    TApplyToolThread *Thread;
    TImageShapeSP Shape;
    out::TResultsList ResultsList;
};

}

#endif // TAPPLYTOOL_P_H
