#include "TEllipseCurveTool.h"
#include "core/core.h"
#include "shape/ShapeManager.h"

namespace graphed {

TEllipseCurveTool::TEllipseCurveTool(TCanvas *c): TTool(c)
{
    Icon = (makeHugeIcon(":/Lithography/ellipse.png"));
    ToolTip = (QObject::tr("Draw Ellipse Arc"));
    setObjectName(ToolName());
}
void TEllipseCurveTool::paint(QPainter *p, const TConversionBase *Convert)
{
    TTool::paint(p, Shape, Convert);
}
void TEllipseCurveTool::mousePressEvent(TMouseEvent *e)
{
    if (e->buttons() & Qt::LeftButton)
    {
        if (!Shape)
        {
            Shape = TEllipseCurveShapeSP(new TEllipseCurveShape);
            Shape->SetCenter(e->posF());
        }
        else
        {
            if (Shape->SetFreePoint(e->posF()))
                FinishShape(Shape);
            else
                Shape->SetNextParam();
        }
    }
    else if ((e->buttons() & Qt::RightButton) && Shape) Shape.clear();
    Canvas->UpdateCanvas();
}
void TEllipseCurveTool::mouseMoveEvent(TMouseEvent *e)
{
    if (!Shape) return;
    Shape->SetFreePoint(e->posF());
    Canvas->UpdateCanvas();
}
void TEllipseCurveTool::Deactivate()
{
    Shape.clear();
    Canvas->UpdateCanvas();
}

}
