#include "TEllipseTool.h"
#include "core/core.h"
#include "shape/ShapeManager.h"

namespace graphed {

TEllipseTool::TEllipseTool(TCanvas *c): TTool(c)
{
    Icon = (makeHugeIcon(":/Lithography/cirk_off.png"));
    ToolTip = (QObject::tr("Draw Circle/Ellipse"));
    setObjectName(ToolName());
}
void TEllipseTool::paint(QPainter *p, const TConversionBase *Convert)
{
    TTool::paint(p, Shape, Convert);
}
void TEllipseTool::mousePressEvent(TMouseEvent *e)
{
    if (e->buttons() & Qt::LeftButton)
    {
        if (!Shape)
        {
            Shape = TEllipseShapeSP(new TEllipseShape);
            Shape->SetCenter(e->posF());
        }
        else
        {
            Shape->SetFreePoint(e->posF());
            FinishShape(Shape);
        }
    }
    else if ((e->buttons() & Qt::RightButton) && Shape) Shape.clear();
    Canvas->UpdateCanvas();
}
void TEllipseTool::mouseMoveEvent(TMouseEvent *e)
{
    if (!Shape) return;
    Shape->SetFreePoint(e->posF());
    Canvas->UpdateCanvas();
}
void TEllipseTool::Deactivate()
{
    Shape.clear();
    Canvas->UpdateCanvas();
}

}
