#include "TImageTool.h"
#include "shape/ShapeManager.h"
#include "widgets/canvas/TConversionBase.h"
#include <QFileDialog>

namespace graphed {

TImageTool::TImageTool(TCanvas *c): TTool(c)
{
    Icon = (makeHugeIcon(":/Lithography/picture.png"));
    ToolTip = (QObject::tr("Load Image From File..."));
    setObjectName(ToolName());
}
void TImageTool::Activate()
{
    Shape = TImageShapeSP(new TImageShape);
    Shape->load(QFileDialog::getOpenFileName(0, tr("Select image"),
                                             "./",
                                             tr("Images (*.bmp *.gif *.jpg *.jpeg *.png *.pbm *.pgm *.ppm *.tiff *.xbm *.xpm)"),
                                             0, QFileDialog::DontUseNativeDialog));
    Shape->SetPosition(Canvas->Conversion()->VirginViewRect().center());
    FinishShape(Shape);
    Canvas->update();
}
}
