#ifndef TINTERACTIONSTRATEGY_H
#define TINTERACTIONSTRATEGY_H

#include "shape/ShapeManager.h"
#include "widgets/canvas/TCanvas.h"

namespace graphed {

class TMouseEvent;
class TInteractionStrategy
{
public:
    const TCanvasQP Canvas;
    const QPointF FirstClick;
    TShapeList SelectedShapes;

    explicit TInteractionStrategy(const TCanvasQP c, const QPointF &PF): Canvas(c), FirstClick(PF) { SelectedShapes = INSTANCE(ShapeManager)->Selection()->SelectedShapes(); }
    virtual ~TInteractionStrategy() { }
    virtual void CancelInteraction() { }
    virtual void handleMouseMove(TMouseEvent *) { }
    virtual void paint(QPainter * /*p*/, const TConversionBase * /*Convert*/) { }
};

}

#endif // TINTERACTIONSTRATEGY_H
