#include "TInteractionTool.h"
#include "TInteractionStrategy.h"

namespace graphed {

TInteractionTool::TInteractionTool(TCanvas *c): TTool(c), CurrentStrategy(NULL)
{
}

void TInteractionTool::mousePressEvent(TMouseEvent *e)
{
    CurrentStrategy = CreateStrategy(e);
    if (!CurrentStrategy) e->ignore();
}
void TInteractionTool::mouseReleaseEvent(TMouseEvent * /*e*/)
{
    if (CurrentStrategy)
    {
        delete CurrentStrategy;
        CurrentStrategy = NULL;
    }
}
void TInteractionTool::paint(QPainter *p, const TConversionBase *Convert)
{
    if (CurrentStrategy) CurrentStrategy->paint(p, Convert);
}
void TInteractionTool::keyReleaseEvent(QKeyEvent *e)
{
    if (!CurrentStrategy) return;
    if (e->key() == Qt::Key_Escape)
    {
        CurrentStrategy->CancelInteraction();
        delete CurrentStrategy; CurrentStrategy = 0;
        e->accept();
    }
}

}
