#include "TPointTool.h"
#include "shape/ShapeManager.h"

namespace graphed {

TPointTool::TPointTool(TCanvas *c): TTool(c)
{
    Icon = (makeHugeIcon(":/Lithography/point.png"));
    ToolTip = (QObject::tr("Draw Point"));
    setObjectName(ToolName());
}
void TPointTool::paint(QPainter *p, const TConversionBase *Convert)
{
    TTool::paint(p, Shape, Convert);
}
void TPointTool::mousePressEvent(TMouseEvent *e)
{
    if (e->buttons() & Qt::LeftButton)
    {
        if (!Shape) Shape = TPointShapeSP(new TPointShape);
        Shape->SetFreePoint(e->posF());
        FinishShape(Shape);
    }
    else if ((e->buttons() & Qt::RightButton) && Shape) Shape.clear();
    Canvas->UpdateCanvas();
}
void TPointTool::mouseMoveEvent(TMouseEvent *e)
{
    if (!Shape) return;
    Shape->SetFreePoint(e->posF());
    Canvas->UpdateCanvas();
}
void TPointTool::Deactivate()
{
    Shape.clear();
    Canvas->UpdateCanvas();
}

}
