#include "TRectTool.h"
#include "core/core.h"
#include "shape/ShapeManager.h"

namespace graphed {

TRectTool::TRectTool(TCanvas *c): TTool(c)
{
    Icon = (makeHugeIcon(":/Lithography/rect_off.png"));
    ToolTip = (QObject::tr("Draw Rectangles"));
    setObjectName(ToolName());
}
void TRectTool::paint(QPainter *p, const TConversionBase *Convert)
{
    TTool::paint(p, Shape, Convert);
}
void TRectTool::mousePressEvent(TMouseEvent *e)
{
    if (e->buttons() & Qt::LeftButton)
    {
        if (!Shape)
        {
            Shape = TRectShapeSP(new TRectShape);
            Shape->SetStartPoint(e->posF());
        }
        else
        {
            Shape->SetEndPoint(e->posF());
            FinishShape(Shape);
        }
    }
    else if ((e->buttons() & Qt::RightButton) && Shape) Shape.clear();
    Canvas->UpdateCanvas();
}
void TRectTool::mouseMoveEvent(TMouseEvent *e)
{
    if (!Shape) return;
    Shape->SetEndPoint(e->posF());
    Canvas->UpdateCanvas();
}
void TRectTool::Deactivate()
{
    Shape.clear();
    Canvas->update();
}
}
