#include "TToolProxy.h"
#include "core/TMouseEvent.h"

namespace graphed {

void TToolProxy::SetActiveTool(TTool *at)
{
    ActiveTool = at;
}
void TToolProxy::mousePressEvent(TMouseEvent *e)
{
    if (ActiveTool) ActiveTool->mousePressEvent(e);
    else e->ignore();
}
void TToolProxy::mouseMoveEvent(TMouseEvent *e)
{
    if (ActiveTool) ActiveTool->mouseMoveEvent(e);
    else e->ignore();
}
void TToolProxy::mouseReleaseEvent(TMouseEvent *e)
{
    if (ActiveTool) ActiveTool->mouseReleaseEvent(e);
    else e->ignore();
}
void TToolProxy::paint(QPainter *p, const TConversionBase *Convert)
{
    if (ActiveTool)
        ActiveTool->paint(p, Convert);
}
void TToolProxy::keyReleaseEvent(QKeyEvent *e)
{
    if (ActiveTool) ActiveTool->keyReleaseEvent(e);
    else e->ignore();
}
void TToolProxy::keyPressEvent(QKeyEvent *e)
{
    if (ActiveTool) ActiveTool->keyPressEvent(e);
    else e->ignore();
}
void TToolProxy::Activate()
{
    if (ActiveTool) ActiveTool->Activate();
}
void TToolProxy::Deactivate()
{
    if (ActiveTool) ActiveTool->Deactivate();
}

}
