#ifndef TTOOLPROXY_H
#define TTOOLPROXY_H

#include <QObject>
#include "core/core.h"
#include "tools/TTool.h"

class QKeyEvent;
class QPainter;

namespace graphed {

class TMouseEvent;
class TConversionBase;
class TToolProxy: public QObject
{
public:
    TToolQP ActiveTool;
    TToolProxy() : ActiveTool(0) { }

    void keyReleaseEvent(QKeyEvent *e);
    void keyPressEvent(QKeyEvent *e);
    void mousePressEvent(TMouseEvent *e);
    void mouseMoveEvent(TMouseEvent *e);
    void mouseReleaseEvent(TMouseEvent *e);
    void paint(QPainter *p, const TConversionBase *Convert);
    void Activate();
    void Deactivate();

    void SetActiveTool(TTool *at);
};

}

#endif // TTOOLPROXY_H
