#ifndef TOOL_MANAGER_H
#define TOOL_MANAGER_H
#include "TTool.h"
#include "tools/TToolProxy.h"
#include <map>
#include <QPushButton>


namespace graphed {

class ToolManagerPrivate;
class ToolManager: public QObject
   {
      Q_OBJECT
      QTPIMPL_PRIVATE(ToolManager)

      ToolManager();
      ~ToolManager();
      static ToolManager *Self;
      static bool IAmBeingCreatedNow;

   signals:
      void SetLockRequest(bool);
      void Params(qreal cx, qreal cy, qreal w, qreal h);

   public:
      static ToolManager *Instance(const int Line = 0, const char *File = NULL);
      static void Destroy();

      typedef QMap<QString, TTool*> TToolMap;
      typedef QList<QPushButton *> TBList;

      const ToolManager::TBList &GetButtonsOfTools();
      TToolProxy *GetToolProxy() const;
      void SetCurrParams(qreal cx, qreal cy, qreal w, qreal h) { emit Params(cx, cy, w, h); }

      const TToolMap &AllTools() const;
   };

}

graphed::TTool *FindTool(const QString name);

#endif // TOOL_MANAGER_H
