#ifndef TOOLMANAGER_P_H
#define TOOLMANAGER_P_H

#include "ToolManager.h"

namespace graphed {

class ToolManagerPrivate: public QObject
   {
      Q_OBJECT
      Q_DECLARE_PUBLIC(ToolManager);

   private slots:
      void on_ToolActivated(const QString &);
   private:
      void AddToolToButtonsOfTools(const QString &Name);

   public:
      ToolManager *q_ptr;
      ToolManagerPrivate();
      virtual ~ToolManagerPrivate();
      void AddTool(TTool *Tool);
      const ToolManager::TBList &CreateButtonsOfTools();
      void ConnectSlots();

      ToolManager::TToolMap AllTools;
      QPointer<TToolProxy> ToolProxy;
      ToolManager::TBList ButtonsOfTools;
      TCanvasQP Canvas;
   };

}

#endif // TOOLMANAGER_P_H
