#ifndef TCHECKABLEBUTTON_H
#define TCHECKABLEBUTTON_H

#include <QPushButton>
#include "core/core.h"

namespace graphed {

class TCheckableButtonPrivate;
class TCheckableButton: public QPushButton
   {
      Q_OBJECT
      QTPIMPL_PRIVATE(TCheckableButton)
      Q_PRIVATE_SLOT(d_func(), void _q_clicked());
   signals:
      void BChecked(bool);
   public:
      TCheckableButton();
      TCheckableButton(const QString &CheckedText, const QString &UnCheckedText);
      TCheckableButton(const QIcon &CheckedIcon, const QIcon &UnCheckedIcon, const QString &CheckedText, const QString &UnCheckedText);
      ~TCheckableButton();

      bool isChecked() const;
      void setChecked(bool Checked);
   };

}

#endif // TCHECKABLEBUTTON_H
