#ifndef TCANVAS_H
#define TCANVAS_H

#include "core/core.h"

#include <QWidget>
#include <QPointer>

namespace graphed {

class TConversionBase;
class ToolManagerPrivate;
class TCanvasPrivate;
class TToolProxy;
class TCanvas: public QWidget
   {
      Q_OBJECT
      QTPIMPL_PRIVATE(TCanvas)

      TCanvas();
      ~TCanvas();
      static TCanvas *Self;
      static bool IAmBeingCreatedNow;

      virtual void keyReleaseEvent(QKeyEvent *e);
      virtual void keyPressEvent(QKeyEvent *e);
      virtual void mousePressEvent(QMouseEvent *e);
      virtual void mouseMoveEvent(QMouseEvent *e);
      virtual void mouseReleaseEvent(QMouseEvent *e);
   public slots:
      void SetProgress(const int Progress, const QString &Text = QString());
   public:
      static TCanvas *Instance(const int Line = 0, const char *File = NULL);
      static void Destroy();

      void UpdateCanvas();
      void paintEvent(QPaintEvent *e);
      void resizeEvent(QResizeEvent *e);
      void SetConversion(TConversionBase *Conv);
      TConversionBase *Conversion() const;
      void SetLocked(const bool Lock);
      TToolProxy *ToolProxy() const;
   };

typedef QPointer<TCanvas> TCanvasQP;

}

#endif // TCANVAS_H
