#ifndef TCONVERSION_H
#define TCONVERSION_H
#include "TConversionBase.h"
#include "shape/TShape.h"

namespace graphed {

class TConversion;
class TConversionPrivate;
class ShapeManager;

class TConversion: public TConversionBase
   {
      Q_OBJECT
      Q_DECLARE_PRIVATE(TConversion);

   signals:
      void GlobalBoundingRectChanged(QRectF NewGBR);
   private slots:
      void on_ShapeChanged(TShapeSP);

   private:
      virtual void DocumentResolutionChanged();
      virtual void OffsetChanged();
      virtual void ViewRectChanged();
      virtual void VirginViewRectChanged();

      void InvalidateCache();

   public:
      TConversion();
      virtual ~TConversion() { }

      void ZoomBy(const QPointF &Center, const qreal zoom);

      QPointF WidgetToViewRect(const QPointF &Pos) const;
      QRectF GlobalBoundingRect()const;
   };

}

#endif // TCONVERSION_H
