#ifndef TCONVERSIONBASE_P_H
#define TCONVERSIONBASE_P_H

#include "TConversionBase.h"
#include <QPointF>
#include <QSize>
#include <QRectF>

namespace graphed {

class TConversionBasePrivate
   {
      Q_DECLARE_PUBLIC(TConversionBase);
   public:
      TConversionBase *q_ptr;

      TConversionBasePrivate();
      virtual ~TConversionBasePrivate() { }
      QPointF Offset;
      qreal Zoom;

      QSize DocumentResolution; //Number of physical points - NX x NY (- 100x300 points)
      QRectF DocumentRect;      //Physical size -10e-6, 3.45e-7, 47e-5 x 60e-6, [DocumentRect] = meter;
      QRectF ViewRect;          //Rect that we are draw. It will be changed by zoom and scroll functions
      QRectF VirginViewRect;    //Not modified by zoom and scroll

      const qreal Margin;
   };

}

#endif // TCONVERSIONBASE_P_H
