#include "TRuler.h"
#include "TRuler_p.h"
#include <qwt_scale_engine.h>
//#include <qwt_abstract_scale_draw.h>

namespace graphed {

TRulerPrivate::TRulerPrivate()
{
    ScaleDiv = new QwtScaleDiv;
    Unit.SetSIUnit(QObject::tr("m"));
}

TRuler::TRuler(QwtScaleDraw::Alignment Align): QwtScaleWidget(Align), d_ptr(new TRulerPrivate)
{
    Q_D(TRuler);
    d->q_ptr = this;
    setTitle(QString());
}
qreal TRuler::min() const
{
    Q_D(const TRuler);
    return d->ScaleDiv->lowerBound();
}
qreal TRuler::max() const
{
    Q_D(const TRuler);
    return d->ScaleDiv->upperBound();
}
void TRuler::setTitle(const QString &Text)
{
    QwtScaleWidget::setTitle(Text);
}
void TRuler::setRange(const qreal Min, const qreal Max)
{
    Q_D(TRuler);
    if (Min - Max == 0) setTitle("invalid range");
    else
    {
        d->Unit.UpdateLegend(Min, Max);
        setTitle(d->Unit.Legend);
        scaleDraw()->Multiplier = d->Unit.Multiplier;
    }
    QwtLinearScaleEngine ScaleEngine;
    *d->ScaleDiv = ScaleEngine.divideScale(Min, Max, 8, 5, 0);
    setScaleDiv(ScaleEngine.transformation(), *d->ScaleDiv);
}


}
