#ifndef TWCANVASCONTROLLER_H
#define TWCANVASCONTROLLER_H

#include <QAbstractScrollArea>
#include "core/core.h"

namespace graphed {

class TWView;
class TCanvas;
class TConversion;
class TWCanvasControllerPrivate;
class TWCanvasController: public QAbstractScrollArea
   {
      friend class TWView;
      Q_OBJECT
      QTPIMPL_PRIVATE(TWCanvasController)

   private slots:
      void on_GlobalBoundingRectChanged(QRectF New);
   public slots:
      void SetBackground(const QImage &Img, Qt::AspectRatioMode AspectRatioMode = Qt::IgnoreAspectRatio);
      void SetDocumentRect(const QRectF &Rect, Qt::AspectRatioMode AspectRatioMode = Qt::IgnoreAspectRatio);
   signals:
      void Scrolled();
      void Zoomed();
   protected:
      void wheelEvent(QWheelEvent *e);
      void resizeEvent(QResizeEvent *e);
      void scrollContentsBy(int dx, int dy);
   public:
      TWCanvasController(TConversion *c);
      ~TWCanvasController() { }

      void ZoomIn(const QPointF &WidgetPos);
      void ZoomOut(const QPointF &WidgetPos);
      void ZoomBy(const QPointF &WidgetPos, qreal Zoom);
      TCanvas *GetCanvas() const;
   };

}
#endif // TWCANVASCONTROLLER_H
