#ifndef TWCANVASCONTROLLER_P_H
#define TWCANVASCONTROLLER_P_H

#include "TWCanvasController.h"
#include "widgets/canvas/TCanvas.h"
#include "widgets/canvas/TConversion.h"

namespace graphed {      

class TViewportWidget: public QWidget
   {
      TCanvasQP Canvas;
      TConversion *Conversion;

   public:

      TViewportWidget(TCanvas *c, TConversion *conv);
      virtual ~TViewportWidget();
      void ResetLayout();
      void ZoomBy(const QPointF &Center, const qreal Zoom) const;
   };

class TWCanvasControllerPrivate
   {
      Q_DECLARE_PUBLIC(TWCanvasController);
   public:
      TWCanvasController *q_ptr;

      TWCanvasControllerPrivate(TConversion *Conv);
      virtual ~TWCanvasControllerPrivate();
      void ResetScrollBars();
      void ScaleBackgroundToNewSize(Qt::AspectRatioMode AspectRatioMode);

      TCanvas *Canvas;
      TConversion *Conversion;
      bool IgnoreScrollSignals;
      TViewportWidget *Viewport;
      QImage BackGround;
   };

}

#endif // TWCANVASCONTROLLER_P_H
