#ifndef TWVIEW_H
#define TWVIEW_H

#include "TWCanvasController.h"
#include "core/core.h"
#include <QWidget>
//#include <core/core.h>

namespace misc { class TQwtScaleBar; }
namespace graphed {

class TConversion;
class TRuler;

class TWViewPrivate;
class TWView: public QWidget
   {
      Q_OBJECT
      QTPIMPL_PRIVATE(TWView)
      Q_PRIVATE_SLOT(d_func(), void _q_UpdateRuler());

   protected:
      TWView();
      static TWView *Self;
      static bool IAmBeingCreatedNow;

      void resizeEvent(QResizeEvent *);
      void showEvent(QShowEvent *);
   protected:
      ~TWView();
   public slots:
      void update_ruler();
      void SetLocked(const bool Lock);
      void SetDocumentRect(const QRectF &Rect);
      void SetDocumentResolution(const QSize &s);
      void sigPos(double x, double y) { emit sig_XYPosition(x, y); }
   signals:
      void sig_XYPosition(double, double);
   public:
      static TWView *Instance(const int Line = 0, const char *File = NULL);
      static void Destroy();
      TConversion *Conversion() const;
      TWCanvasController *CanvasController() const;
   };

}

#endif // TWVIEW_H
